﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using TestDDL.Models;

namespace TestDDL.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            return View();
        }
        [HttpGet]
        public JsonResult GetOrganizations()
        {
            List<TestOrganizationModel> Organizations;
            if (Session["Organizations"] == null)
            {
                Organizations = new List<TestOrganizationModel>();
                TestOrganizationModel myOrg = new TestOrganizationModel
                {
                    OrganizationName = "Organization 1"
                };
                Organizations.Add(myOrg);

                myOrg = new TestOrganizationModel
                {
                    OrganizationName = "Organization 2"
                };
                Organizations.Add(myOrg);

                myOrg = new TestOrganizationModel
                {
                    OrganizationName = "Organization 3"
                };
                Organizations.Add(myOrg);

                myOrg = new TestOrganizationModel
                {
                    OrganizationName = "Organization 4"
                };
                Organizations.Add(myOrg);

                Session["Organizations"] = Organizations;
            }
            else
            {
                Organizations = (List<TestOrganizationModel>)Session["Organizations"];
            }
            //return Organizations;
            return Json(Organizations, JsonRequestBehavior.AllowGet);
        }
        #region Add Organization
        /// <summary>
        /// Used by logged in users creating resource as well as SuperAdmin users.
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public ActionResult AddOrganization()
        {
            TestOrganizationModel myOrg = new TestOrganizationModel { OrganizationName = "" };
            ViewBag.Title = "Add Organization";
            return View("_AddOrgModal", myOrg);
        }

        [HttpPost]
        public ActionResult AddOrganization(TestOrganizationModel details)
        {
            if (ModelState.IsValid)
            {
                List<TestOrganizationModel> myOrgs = (List<TestOrganizationModel>)Session["Organizations"];
                TestOrganizationModel myNewOrg = new TestOrganizationModel
                {
                    OrganizationName = details.OrganizationName
                };
                myOrgs.Add(myNewOrg);
                Session["Organizations"] = myOrgs;
                ViewBag.Success = true;
                ViewBag.Title = "Add Organization";
                return View("_AddOrgModal", details);
            }
            ViewBag.Title = "Add Organization";
            return View("_AddOrgModal", details);
        }
        #endregion
    }
}